// miscellaneous enums
// Copyright © 2009 The University of Chicago
#ifndef GENERALDEFINITIONS_H
#define GENERALDEFINITIONS_H

enum eCurrentDisplay
{
	eGraphics, 
	eCollection
};

enum eWhichTree
{
  Upper,
  Lower
};

enum eDocumentType  // for the Collection View
{
  NO_DOC,
  CORPUS_DOC,
  WORDS,
  ANALYZED_WORDS,
  PROPER_NAMES,
  TEMPWORDS,
  STEMS,
  STEMS_SUFFIXED,
  STEMS_PREFIXED,
  ROOTS,
  MDL_TYPE,
  SIGNATURES,
  PREFIX_SIGNATURES,
  SUFFIX_SIGNATURES,
  PREFIX_SIGNATURE_SUBSET,
  INNER_SIGNATURES,
  SIGNATURE_SUBSET,
  SUFFIXES,
  PREFIXES,
  COMPOUNDS,
  COMPOUND_COMPONENTS,
  LINKERS,
  CORPUS_WORDS,
  ANALYZED_CORPUS_WORDS,
  ALL_WORDS,
  ALL_ANALYZED_WORDS,
  ALL_STEMS,
  ALL_SUFFIXES,
  ALL_SUFFIX_SIGNATURES,
  ALL_PREFIXES,
  ALL_PREFIX_SIGNATURES,
  COMPOUND_ELEMENTS, // first and second members of compounds
  TEMP_SUFFIXES,
  TEMP_STEMS,
  GOOD_BEGINNINGS,
  GOOD_ENDINGS,
  POLYMORPHEMES,
  POLYWORDS,
  RULES,
  MORPHEMES,
  FIRST_MORPHEME,
  SECOND_MORPHEME,
  REVERSE_TRIE,
  TRIE,
  EIGENVECTOR,
  COLLAPSE_TWO_SIGNATURES,
  COLLOCATIONS,
  PROBLEM_SIGNATURES,
  LITTLE_SIGNATURES,
  BAD_WORDS,
  PREFIX_TRIE,
  PREFIX_SIGNATURES_OF_ROOTS,
  ROOTS_SUFFIXES_PREFIXES,
  STEM_TRIE,
  REVERSE_STEM_TRIE,
  INITIAL_TEMPLATES,
  PREFIXING_TEMPLATES,
  TEMPLATES,
  GOLDSTANDARD,
  TOKENS_REQUESTED,
  MINI_LEXICON,
  BORROWED_SIGNATURES,
  FSA_DOC,
  INITIALMORPHOLOGY,
  WORKINGMORPHOLOGY,
  PREFIXINITIALMORPHOLOGY,
  PREFIXWORKINGMORPHOLOGY,
  HMM_LEXICON,
  HMM_CORPUS,
  STRINGEDITDISTANCE,
  INITIALSTRINGEDITTEMPLATES,
  WORKINGSTRINGEDITTEMPLATES,
  BIPHONES,
  PHONES,
  PHONES_Tier2,
  BIPHONES_Tier2,
  PHONES_Tier1_Skeleton,
  BIPHONES_Tier1_Skeleton,
  DESCRIPTION_LENGTH,
  DESCRIPTION_LENGTH_HISTORY,
  HMM_Document,
  BIGRAM_INFORMATION,
  UNIGRAM_INFORMATION,
  TIER2MI,
  UNANALYZED_WORDS,
  POS // Parts of speech.
};


enum eSortStyle
{
  KEY,
  REVERSE_KEY,
  CORPUSCOUNT,
  COUNT,
  SIGS,
  PARSE_SIZE,
  RULE_USE,
  LENGTH,
  DL_SAVINGS,
  FREQUENCY,
  MORPHEMECOUNT,
  MORPHEME_GOODNESS,
  SIGS_NUMBER_OF_STEMS,
  STEM_SUFFIXES,
  USECOUNT,
  SIG_REMARK,
  STEM_SOURCE,
  SIG_MENTORS,
  TEMPLATE_SORT,
  TEMPLATE_SORT_COLUMN
};


enum eBiphoneSortStyle
{
	MI,
	WMI,
	BIPHONE_KEY
};


enum ePhoneSortStyle
{
	PHONE_FREQ,
	PHONE_KEY
};

enum eInterfaceMessages
{
  ADD_WORDS,
  ADD_TEMPWORDS,
  ADD_SIGNATURES,
  ADD_PREFIX_SIGNATURES,
  ADD_STEMS,
  ADD_SUFFIXES,
  ADD_PREFIXES,
  ADD_MAXIMUM_SUFFIX_LENGTH,
  ADD_MAXIMUM_PREFIX_LENGTH,
  ADD_MINIMUM_SIGNATURE_LENGTH,
  ADD_MIN_LENGTH_STEM,
  ADD_MINIMUM_LENGTH_SIGNATURE,
  ADD_MINIMUM_NUMBER_STEMS_IN_SIGNATURE,
  ADD_MAX_SUCCESSOR_FREQ_SCORE,
  ADD_COMPOUNDS,
  ADD_TRIGRAM_BRANCHES,
  ADD_POLYMORPHEMES,
  ADD_POLYWORDS,
  ADD_THRESHOLD,
  ADD_FIND_GOOD_WORDINITIALS,
  ADD_INPUT_DOCUMENT_TYPE,
  ADD_GOOD_BEGINNINGS,
  ADD_PROPER_NAMES
};


enum eWindow
{
  TREE,
  COLLECTION,
  EDITVIEW
};


enum ePossibleStates
{
  NONE,
  LIST_OF_SIGNATURES,
  LIST_OF_PREFIX_SIGNATURES
};


enum eSuccessorFrequencyMode
{
  SF1,  //, peak and neighbors are only "1"
  SF2,  //, peak, and both stem and suffix are already identified.
  SF3    //peak, that's all
};


enum eInputDocumentType
{
  CORPUS,
  WORDLIST    // we will ignore proper names in this case
};


enum eNodeType
{
  DataNode,
  BranchingNode,
  BadType
};


enum eLockState
{
  Locked,
  Unlocked
};

enum eAlignmentOperation
{
  FromBelow,
  FromLeft,
  FromBelowAndLeft,
  Start,
  End,
  IdenticalMatch,
  NonIdenticalMatch
};


enum eAllomorphyType
{
  SuffixAllomorphy,
  StemAllomorphy,
  SignatureAllomorphy
};

enum eSplitType
{
  LENGTHWEIGHTING,
  NOLENGTHWEIGHTING,
  BOLTZMANN,
  BOLTZMANN2
};


enum eVerifyResult
{
  RESULT_CANCEL,
  RESULT_YES,
  RESULT_NO
};

enum eAffixationType
{
	TYPE_Prefix,
	TYPE_Suffix,
	TYPE_Unknown
};

enum eTier
{
	TIER_1,
	TIER_2,
	TIER_1_SKELETON
};

enum eModelType
{
	UNIGRAM,
	BIGRAM
};

enum eHmmDataType
{
	HMMNONE,
	PHONE_TIER1,
	PHONE_TIER2,
	PARSE
};

enum eMDL_STYLE
{
	CorpusCount,
	GrammarCount
};

enum eRecomputeStyle
{
	Recompute,
	ComputeOnlyIfNecessary
};

enum eStateType
{
    StartState,
    AcceptState,
    NormalState
};

#endif // GENERALDEFINITIONS_H
